<template>
  <div class="flex px-6 my-12">
    <div class="w-[40%]  min-h-[30%]">
      <h1 class="text-7xl font-black mb-4">{{ manga?.title }}</h1>
      <h2 class="text-5xl font-black mb-2">{{ manga?.jap_title }}</h2>
      <template v-if="manga?.themes?.length">
        <h5 class="mb-0 mt-2">Themes</h5>
        <tags-cloud class="mb-3" :tags="manga?.themes ?? []" />
      </template>
      <template v-if="manga?.genres?.length">
        <h5 class="mb-0 mt-2">Genres</h5>
        <tags-cloud class="mb-3" :tags="manga?.genres ?? []" type="secondary" />
      </template>
      <p class="font-semibold">{{ manga?.description }}</p>
      <Detail
          @add-to-library="updateUserLibrary"
          :data="detailsData"
          class="bg-white rounded-3xl shadow-lg w-[160%] relative z-20 ml-3 mt-8"
      />
      <button @click="discover" class="mt-12 flex px-6 justify-center bg-[#A370F0] rounded-[0.9em] text-white font-bold py-3 rounded-lg">
        Make another discovery
      </button>
    </div>
    <div class="w-[60%] px-12">
      <img class="rounded-3xl w-full h-[55vh] object-cover relative z-0" :src="manga?.picture" alt="cover"/>
    </div>
  </div>
</template>

<script>
import Detail from "../components/manga/Detail.vue";
import TagsCloud from "../components/TagsCloud.vue";
import Cover from "../components/manga/Cover.vue";
import title from "../helpers/title.js";

export default {
  name: "Details",
  components: {Cover, TagsCloud, Detail},
  data() {
    return {
      manga: null,
      inLibrary: false
    }
  },

  mounted() {
    title("Discover")
    this.discover()
  },

  computed: {
    detailsData() {
      return {
        status: {'Completed': 1, 'Ongoing': 0}[this.manga?.status ?? 'Ongoing'],
        volumes: this.manga?.volumes,
        chapters: this.manga?.chapters,
        releaseDate: this.manga?.release_date,
        library: this.inLibrary
      }
    },
  },

  methods:{
    discover(){
      let old_discovery = this.manga?.id
      this.$axios.get(`/feed/discover?count=2`).then(({data}) => {
        if (data[0].id === old_discovery && data.length > 1){
          this.manga = data[1]
        }else{
          this.manga = data[0]
        }
      })
      if(this.$store.auth){
        this.$axios.get(`/users/${this.$store.user.id}/relations/mangas`).then(({data}) => {
          this.inLibrary = data.find(manga => manga.api_id === this.manga.api_id) !== undefined
        })
      }
    },
    updateUserLibrary(){
      if(this.$store.auth) {
        const params = new URLSearchParams();
        if (this.inLibrary) {
          params.append('id', this.manga.id);
          this.$axios.delete(`/users/${this.$store.user.id}/relations/mangas`, {
            data: params,
            headers: {
              'Access-Control-Allow-Origin': 'http://localhost/* , http://127.0.0.1/*',
              'Authorization': this.$store.userToken
            }
          }).then(({status}) => {
            if(status === 200){
              this.inLibrary = false
            }
          })
        } else {
          params.append('ids', this.manga.id);
          this.$axios.post(`/users/${this.$store.user.id}/relations/mangas`, params, {
            headers: {
              'Access-Control-Allow-Origin': 'http://localhost/* , http://127.0.0.1/*',
              'Authorization': this.$store.userToken
            }
          }).then(({status}) => {
            if(status === 200){
              this.inLibrary = true
            }
          })

        }
      }
    },
  },

  watch:{
    async '$route.params.id'(data, old){
      if(old && data){
        await this.$axios.get(`/mangas/${this.$route.params.id}`).then(({data}) => {
          this.manga = data
        })

        if(this.$store.auth){
          await this.$axios.get(`/users/${this.$store.user.id}/relations/mangas`).then(({data}) => {
            this.inLibrary = data.find(manga => manga.api_id === this.manga.api_id) !== undefined
          })
        }
      }
    }
  }
}
</script>